## android-platform-tools 33.0.3

=== ide/clion/frameworks/native/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(native)
add_subdirectory(libs/gui/libgui-arm64-android)
add_subdirectory(libs/ui/libui-arm64-android)
add_subdirectory(libs/renderengine/librenderengine-arm64-android)
add_subdirectory(services/surfaceflinger/surfaceflinger-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine_mocks-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine_test-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine-arm64-android)
add_subdirectory(services/surfaceflinger/FrameTimeline/libframetimeline-arm64-android)
add_subdirectory(services/surfaceflinger/TimeStats/timestatsproto/libtimestats_proto-arm64-android)
add_subdirectory(services/surfaceflinger/TimeStats/libtimestats-arm64-android)
add_subdirectory(services/surfaceflinger/layerproto/liblayers_proto-arm64-android)
add_subdirectory(services/surfaceflinger/tests/IPC_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/fakehwc/sffakehwc_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/SurfaceFlinger_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/vsync/test-vsync-events-arm64-android)
add_subdirectory(services/surfaceflinger/tests/waitforvsync/test-waitforvsync-arm64-android)
add_subdirectory(services/surfaceflinger/tests/unittests/libsurfaceflinger_unittest-arm64-android)
add_subdirectory(services/surfaceflinger/libSurfaceFlingerProp-arm64-android)
add_subdirectory(services/surfaceflinger/sysprop/libSurfaceFlingerProperties-arm64-android)

=== debian/changelog ===
android-platform-tools (33.0.3-2~bpo11+2) bullseye-backports-sloppy; urgency=medium

  * Use system's libfmt-dev instead of local copy under external folder.

 -- Roger Shimizu <rosh@debian.org>  Tue, 05 Sep 2023 00:08:49 -0700

android-platform-tools (33.0.3-2~bpo11+1) bullseye-backports-sloppy; urgency=medium

  * Rebuild for bullseye-backports-sloppy.
  * debian/patches: Add patches to fix ftbfs for old compiler.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jul 2023 23:43:26 -0700

android-platform-tools (33.0.3-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * debian/include:
    - Remove local chrono header, which was for gcc-13.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jul 2023 22:18:16 -0700

android-platform-tools (33.0.3-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/include:
    - Add chrono header from libstdc++-13-dev to fix ftbfs for gcc-13
      (Closes: #1037576).
  * debian/patches:
    - Add a missing header to fix ftbfs for gcc-13.

 -- Roger Shimizu <rosh@debian.org>  Sat, 22 Jul 2023 21:50:37 -0700

android-platform-tools (33.0.3-2~exp1) experimental; urgency=medium

  * Add e/libcpu_features.so for android-platform-art/13.

 -- Roger Shimizu <rosh@debian.org>  Tue, 11 Jul 2023 01:09:14 -0700

android-platform-tools (33.0.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Sun, 09 Jul 2023 19:49:29 -0700

android-platform-tools (33.0.3-1~exp9) experimental; urgency=medium

  * Merge changes till debian/29.0.6-28
  * debian/control:
    - Remove D-B libpcre3-dev, which is not used (Closes: #1000022).

 -- Roger Shimizu <rosh@debian.org>  Sun, 09 Jul 2023 19:32:47 -0700

android-platform-tools (33.0.3-1~exp8) experimental; urgency=medium

  * Team upload.
  * debian/patches: Add patch to fix ftbfs issue for
    src:android-platform-frameworks-base.

 -- Roger Shimizu <rosh@debian.org>  Sat, 11 Feb 2023 02:12:23 -0800

android-platform-tools (33.0.3-1~exp7) experimental; urgency=medium

  * Team upload.
  * debian/patches: Cleanup, remove no longer necessary patches.
  * debian/rules: Add target "update" to gbp import new release.

 -- Roger Shimizu <rosh@debian.org>  Thu, 09 Feb 2023 23:07:22 -0800

android-platform-tools (33.0.3-1~exp6) experimental; urgency=medium

  * Team upload.
  * Fix ftbfs on armel.
  * debian folder: Cleanup.

 -- Roger Shimizu <rosh@debian.org>  Wed, 08 Feb 2023 00:06:09 -0800

android-platform-tools (33.0.3-1~exp5) experimental; urgency=medium

  * Team upload.
  * Use lld when possible except riscv64.
  * Use ronn to make manpages when pandoc is not available.
  * d/control: Fix ftbfs on powerpc due to clang.
  * d/lintian-overrides: Add
    package-has-unnecessary-activation-of-ldconfig-trigger.

 -- Roger Shimizu <rosh@debian.org>  Sat, 28 Jan 2023 01:03:44 -0800

android-platform-tools (33.0.3-1~exp4) experimental; urgency=medium

  * Team upload.
  * debian/control: Add Breaks/Replaces to pass piuparts test.

 -- Roger Shimizu <rosh@debian.org>  Mon, 23 Jan 2023 23:36:55 -0800

android-platform-tools (33.0.3-1~exp3) experimental; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Update standards version to 4.6.2, no changes needed.
  * Use correct machine-readable copyright file URI.

  [ Roger Shimizu ]
  * d/control: Sync multi-arch hints with master branch

  [ Jochen Sprickerhof ]
  * Add patch to fix FTBFS (Closes: #1027653)

 -- Roger Shimizu <rosh@debian.org>  Sat, 21 Jan 2023 01:14:43 -0800

android-platform-tools (33.0.3-1~exp2) experimental; urgency=medium

  * debian/patches: Add patch to fix ftbfs for mips*.

 -- Roger Shimizu <rosh@debian.org>  Sun, 20 Nov 2022 14:46:10 -0800

android-platform-tools (33.0.3-1~exp1) experimental; urgency=medium

  * New upstream release 33.0.3
  * debian/patches: Amend patch to add more includes to header files.
  * debian/rules: Export gdwarf-4.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Oct 2022 15:03:25 -0700

android-platform-tools (33.0.1-1~exp9) experimental; urgency=medium

  * Team upload.
  * debian/upstream/metadata:
    - Update link for reporting and checking issues.
  * debian/control: Make pkg description in more detail.
  * debian/copyright: Update to list new source files.
  * Remove e/libcpu_features.so since it's not necessary.
  * Add pkg android-platform-frameworks-native-headers.

 -- Roger Shimizu <rosh@debian.org>  Fri, 01 Jul 2022 01:49:46 +0900

android-platform-tools (33.0.1-1~exp8) experimental; urgency=medium

  * Team upload.
  * debian/extra/incremental_delivery:
    - Patch map_ptr.h to support operator-- for libstdc++.
  * debian/*.mk:
    - Remove -pie from common LDFLAGS and only apply to LDFLAGS for
      non-library build.
  * debian/*.install: Move symbolic link library to -dev package.
  * debian/rules:
    - mkdir debian/out folder instead of in d/*.mk
    - Add common CPPFLAGS.
  * debian/control: Fix -dev package Arch support list.

 -- Roger Shimizu <rosh@debian.org>  Tue, 14 Jun 2022 23:02:26 +0900

android-platform-tools (33.0.1-1~exp7) experimental; urgency=medium

  * Team upload.
  * Revert 1 upstream patch to restore mips support for libbacktrace.
  * debian/control:
    - Remove Depends on p7zip-full, since we already switched to
      external/lzma.

 -- Roger Shimizu <rosh@debian.org>  Wed, 08 Jun 2022 20:15:50 +0900

android-platform-tools (33.0.1-1~exp6) experimental; urgency=medium

  * Team upload.
  * Add new repo system/incremental_delivery:incfs/util to debian/extra.
  * debian/control:
    - Fix Depends version for android-platform-system-core-headers.
  * debian/android-libbase-dev.install: Add fmtlib header.
  * debian/*.mk: Minor fix for libbacktrace and libutils.

 -- Roger Shimizu <rosh@debian.org>  Sun, 05 Jun 2022 23:21:33 +0900

android-platform-tools (33.0.1-1~exp5) experimental; urgency=medium

  * Team upload.
  * debian/control: Convert android-*-dev to Architecture: any
    (Closes: #982326).


=== debian/control ===
Source: android-platform-tools
Section: devel
Priority: optional
Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders:
 Roger Shimizu <rosh@debian.org>,
Build-Depends:
 bash-completion,
 debhelper-compat (= 13),
 dh-exec,
Build-Depends-Arch:
 android-libboringssl-dev (>= 12) [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 clang [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el s390x ppc64 sparc64 riscv64],
 libbrotli-dev [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libfmt-dev (<< 9) [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libgtest-dev,
 liblz4-dev [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libpng-dev,
 libprotobuf-dev (>= 3.12) [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libsquashfuse-dev [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libusb-1.0-0-dev [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 libzstd-dev [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 lld [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el],
 pandoc [amd64 i386 armel armhf arm64 hppa ia64 mipsel mips64el ppc64el s390x alpha ppc64 sparc64 riscv64],
 protobuf-compiler (>= 3.12) [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 python3 [amd64 i386 arm64],
 ronn [arc hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpc sh4 x32],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/android-tools-team/android-platform-tools.git
Vcs-Browser: https://salsa.debian.org/android-tools-team/android-platform-tools
Homepage: https://developer.android.com/studio/releases/platform-tools

Package: android-sdk-libsparse-utils
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
         android-libsparse (= ${binary:Version}),
         python3,
Breaks: android-tools-fsutils,
        append2simg (<< 1:10.0.0+r36-1~),
        img2simg (<< 1:10.0.0+r36-1~),
        simg2img (<< 1:10.0.0+r36-1~)
Replaces: android-tools-fsutils,
          append2simg (<< 1:10.0.0+r36-1~),
          img2simg (<< 1:10.0.0+r36-1~),
          simg2img (<< 1:10.0.0+r36-1~)
Description: Android sparse image creation tool
 Command line tools to create sparse images for usage with Android devices.
 Includes simg2img, img2simg, simg2simg, simg_dump and append2simg tools.

Package: android-liblog
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: android-liblog-dev (<< 1:33)
Description: Android NDK logger interfaces
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.

Package: android-liblog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-liblog (= ${binary:Version}),
Breaks: android-liblog (<< 1:33)
Replaces: android-liblog (<< 1:33)
Description: Android NDK logger interfaces - Development files
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.
 .
 This package contains the development files.

Package: android-libcutils
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
         libbsd0,
Breaks: android-libcutils-dev (<< 1:33)
Description: Android utils library for C
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.

Package: android-libcutils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libcutils (= ${binary:Version}),
         android-libbase-dev (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
         libbsd-dev,
Breaks: android-libcutils (<< 1:33)
Replaces: android-libcutils (<< 1:33)
Description: Android utils library for C - Development files
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: adb
Section: utils
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-libcutils (= ${binary:Version}),
Recommends: android-sdk-platform-tools-common (>= 28.0.2~)
Provides: android-tools-adb
Description: Android Debug Bridge
 A versatile command line tool that lets you communicate with an emulator
 instance or connected Android-powered device.
 .
 This package recommends "android-sdk-platform-tools-common" which contains
 the udev rules for Android devices. Without this package, adb and fastboot need
 to be running with root permission.

Package: android-libsparse
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-libbase (= ${binary:Version}),
Breaks: android-libsparse-dev (<< 1:33)
Description: Library for sparse files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.

Package: android-libsparse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libsparse (= ${binary:Version}),
Breaks: android-libsparse (<< 1:33)
Replaces: android-libsparse (<< 1:33)
Description: Library for sparse files - Development files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libutils
Section: libs
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbacktrace (= ${binary:Version}),
         android-libcutils (= ${binary:Version}),
Breaks: android-libutils-dev (<< 1:33)
Description: Android Utility Function Library
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.

Package: android-libutils-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace-dev (= ${binary:Version}),
         android-libcutils-dev (= ${binary:Version}),
         android-libutils (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
Breaks: android-libutils (<< 1:33)
Replaces: android-libutils (<< 1:33)
Description: Android Utility Function Library - Development files
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libziparchive
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
Breaks: android-libziparchive-dev (<< 1:33)
Description: Library for ZIP archives
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.

Package: android-libziparchive-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libziparchive (= ${binary:Version}),
         libgtest-dev,
Breaks: android-libziparchive (<< 1:33)
Replaces: android-libziparchive (<< 1:33)
Description: Library for ZIP archives - Development files
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-platform-frameworks-native-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Headers of android-platform-frameworks-native
 This package contains headers in include/android in platform/frameworks/native
 Consists of all the header files ranging from asset_manager.h to window.h.

Package: android-platform-system-core-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: android-libunwind-dev (<< 10.0.0+r36-5)
Description: Shared headers in AOSP repository platform/system/core
 This package contains header files in AOSP repository platform/system/core that
 do not belong to any specific libraries but used by other programs.
 .
 This package currently contains headers in include/private and include/system.

Package: android-libbacktrace
Section: libs
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
Breaks: android-libbacktrace-dev (<< 1:33)
Description: Android backtrace library
 Android backtrace library produce symbolic backtraces for making
 debugging easier.

Package: android-libbacktrace-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace (= ${binary:Version}),
Breaks: android-libbacktrace (<< 1:33)
Replaces: android-libbacktrace (<< 1:33)
Description: Android backtrace library - Development files
 Android backtrace library produce symbolic backtraces for making
 debugging easier.
 .
 This package contains the development files.

Package: android-libbase
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-liblog (= ${binary:Version}),
Breaks: android-libbase-dev (<< 1:33)
Description: Android base library
 This library provides APIs for basic tasks like handling files, Unicode
 strings, logging, memory allocation, integer parsing, etc..
 .
 This library is only used by Android SDK currently.

Package: android-libbase-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbase (= ${binary:Version}),
         android-liblog-dev (= ${binary:Version}),
Breaks: android-libbase (<< 1:33)
Replaces: android-libbase (<< 1:33)
Description: Android base library - Development files
 This library provides APIs for basic tasks like handling files, Unicode
 strings, logging, memory allocation, integer parsing, etc..
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libnativehelper
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-liblog (= 1:${binary:Version}),
Breaks: android-libnativehelper-dev (<< 33)
Replaces: android-libnativehelper-dev (<< 33)
Description: Support functions for Android's class libraries
 libnativehelper is a collection of JNI related utilities used in
 Android.
 .
 There are several header and binary libraries here and not all of the
 functionality fits together well. The header libraries are mostly C++
 based. The binary libraries are entirely written in C with no C++
 dependencies. This is by design as the code here can be distributed in
 multiple ways, including mainline modules, so keeping the size down
 benefits everyone with smaller downloads and a stable ABI.

Package: android-libnativehelper-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libnativehelper (= ${binary:Version}),
Breaks: android-libnativehelper (<< 33)
Replaces: android-libnativehelper (<< 33)
Description: Support functions for Android's class libraries - Development files

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

## Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
# https://android.googlesource.com/platform/build/soong/+/refs/tags/platform-tools-33.0.3/cc/config/global.go#299
export DEB_CFLAGS_MAINT_APPEND = -fPIC -gdwarf-4
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC -gdwarf-4
export DEB_LDFLAGS_MAINT_APPEND = -fPIC
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -UDEBUG \
  -fmessage-length=0 \
  -fno-exceptions \
  -fno-strict-aliasing \
  -no-canonical-prefixes \

ifneq (, $(shell which lld))
  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld -Wl,--build-id=sha1
endif

## For get-orig-source
export DEB_SOURCE

## system
export DEB_HOST_MULTIARCH
export DEB_VERSION
# https://android.googlesource.com/platform/development/+/refs/tags/platform-tools-33.0.3/sdk/plat_tools_source.prop_template
export PLATFORM_TOOLS_VERSION = 33.0.3

ifneq (, $(shell which clang))
  export CC=clang
  export CXX=clang++
  export DEB_CPPFLAGS_MAINT_APPEND += \
    -Wno-c99-designator \
    -Wno-gnu-designator \
    -Wno-gnu-folding-constant \

endif

%:
	dh $@ --with bash-completion

# Depends: git-buildpackage repo
get-orig-source:
	debian/scripts/get-orig-source

ifeq ("$(wildcard ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz)","")
update: get-orig-source
else
update:
endif
	gbp import-orig ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz \
		--no-interactive --debian-branch=$(shell git symbolic-ref --short HEAD) \
		--postimport="\
		dch -b -v\$$GBP_DEBIAN_VERSION \"New upstream release \$$GBP_UPSTREAM_VERSION\"; \
		git add debian/changelog; \
		git commit -m\"dch: Note new upstream version \$$GBP_UPSTREAM_VERSION\""

## system

e/lib%.so: debian/external/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

s/lib%.a: debian/system/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

s/lib%.so: debian/system/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

debian/manpages/system/%.1: debian/manpages/system/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

s/libbacktrace.so: debian/system/libbacktrace.mk s/libcutils.so e/liblzma.so e/libcpu_features.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/libbase.so: debian/system/libbase.mk s/liblog.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/libcutils.so: debian/system/libcutils.mk s/libbase.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/adb: debian/system/adb.mk s/libziparchive.so s/libadb.a s/libcrypto_utils.a s/libcutils.so debian/manpages/system/adb.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/fastboot: debian/system/fastboot.mk s/adb s/extras/libext4_utils.a s/libsparse.so debian/manpages/system/fastboot.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2img: debian/system/simg2img.mk s/libbase.so s/libsparse.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2simg: debian/system/simg2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/img2simg: debian/system/img2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/append2simg: debian/system/append2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS = \
  e/libcpu_features.so \
  e/liblzma.so \
  s/append2simg \
  s/img2simg \
  s/libbacktrace.so \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libutils.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

# Whatever depends on BoringSSL must be disabled on MIPS
NON_MIPS_COMPONENTS = s/adb s/fastboot
ifneq ($(filter amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
  COMPONENTS += $(NON_MIPS_COMPONENTS)
endif

# Most components only support ARM, x86 and MIPS, but some can be built
# on all architectures.
COMPONENTS_ANY_ARCH = \
  s/append2simg \
  s/img2simg \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

ifeq ($(filter amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
  COMPONENTS := $(filter $(COMPONENTS_ANY_ARCH), $(COMPONENTS))
endif

## development

debian/manpages/development/%.1: debian/manpages/development/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

development/etc1tool: debian/development/etc1tool.mk debian/manpages/development/etc1tool.1 f/native/libETC1.a
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += development/etc1tool

## frameworks/native

f/native/libETC1.a: debian/frameworks/native/libETC1.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += f/native/libETC1.a

## system/extras

s/extras/libext4_utils.a: debian/system/extras/libext4_utils.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

## libnativehelper

libnativehelper/libnativehelper.so: debian/libnativehelper/libnativehelper.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += libnativehelper/libnativehelper.so

## dalvik

dalvik/hprof-conv: debian/dalvik/hprof-conv.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += dalvik/hprof-conv

## external

e/lib%.so: debian/external/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

override_dh_auto_build-arch: $(COMPONENTS)

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch:
	debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.png --encode && debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.pkm --decode
ifneq ($(filter amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb help
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb keygen key.txt && ls -l key.txt* && rm key.txt*
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot --version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot devices
endif
endif

override_dh_auto_install:
	echo ignore upstream build system install procedure

override_dh_auto_configure-arch:
	rm -rf external/dlmalloc external/fmtlib development/[a-s]* development/v* development/testrunner
	mkdir -p debian/out/dalvik/tools debian/out/development debian/out/external \
		debian/out/frameworks/native debian/out/system/extras debian/out/libnativehelper
ifneq ($(filter amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
	for proto in packages/modules/adb/fastdeploy/proto packages/modules/adb/proto; do \
		(cd $$proto && \
			find . -name '*.proto' -printf 'Regenerate %p\n' \
			-exec protoc --cpp_out=. {} \;) \
	done
endif

override_dh_gencontrol:
	dh_gencontrol
	dh_gencontrol -padb -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libziparchive -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libziparchive-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-platform-frameworks-native-headers -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-platform-system-core-headers -- -v1:$(DEB_VERSION)
